/*
 * Created on 2004/08/16
 * Author aki@www.xucker.jpn.org
 * License Apache2.0 or Common Public License
 */
package org.jpn.xucker.commons.swt.ui;

import java.util.List;
import java.util.Vector;

/**
 * 
 *
 */
public class FileStatusChanger {
    private List fileListChangeListener=new Vector();
    
    public synchronized void removeFileListChangeListener(FileStatusChangeListener listener){
     fileListChangeListener.remove(listener);   
    }
    
    public synchronized void addFileListChangeListener(FileStatusChangeListener listener){
        fileListChangeListener.add(listener);   
       }
    
    public void fireRemoveFile(String file){
        
        FileStatusChangeEvent event=new FileStatusChangeEvent(this,file);
        synchronized(this){
            FileStatusChangeListener[] listeners=(FileStatusChangeListener[])fileListChangeListener.toArray(new FileStatusChangeListener[fileListChangeListener.size()]);
            
            for (int i = 0; i < listeners.length; i++) {
                
                listeners[i].removeList(event);
            }
        }
    }
    
    public void fireAddFile(String file){
        FileStatusChangeEvent event=new FileStatusChangeEvent(this,file);
        synchronized(this){
            FileStatusChangeListener[] listeners=(FileStatusChangeListener[])fileListChangeListener.toArray(new FileStatusChangeListener[fileListChangeListener.size()]);
            for (int i = 0; i < listeners.length; i++) {
                listeners[i].addList(event);
            }
        }
    }
}
